/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2006 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer:
*/

#include "blink.h"

#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "debug.h"


#include "material.h"






ObjectListDefinition(Blink);
CREATE_FACTORY(Blink);

/**
 * standart constructor
 */
Blink::Blink (const TiXmlElement* root)
{
  this->init();

  if( root)
    this->loadParams(root);
}


/**
 * destroys a Blink
 */
Blink::~Blink ()
{
  if (this->material)
    delete this->material;
}


/**
 * initializes the Blink
 */
void Blink::init()
{
  this->registerObject(this, Blink::_objectList);
  this->setName("Blink");

  this->toList(OM_COMMON);

  this->material = new Material();
  //this->material->setIllum(0);
  //this->material->setDiffuse(1.0,1.0,1.0);
  //this->material->setTransparency(0.0);
 // this->material->setSpecular(0.0,0.0,0.0);
 // this->material->setAmbient(1.0, 1.0, 1.0);
  this->material->setBlendFunc(GL_ZERO,GL_ZERO);
  this->material->setDiffuseMap("maps/acid3.png");
  //this->setAbsCoor(0, 0, 0);d
  //this->setVisibiliy(true);
  // this->setSize(5, 5);
}


/**
 *  load params
 * @param root TiXmlElement object
 */
void Blink::loadParams(const TiXmlElement* root)
{
  /*LoadParam(root, "texture", this->material, Material, setDiffuseMap)
      .describe("the texture-file to load onto the Blink");

  LoadParam(root, "size", this, Blink, setSize)
  .describe("the size of the Blink in Pixels");*/
}


/**
 * ticks the Blink
 * @param dt the time to ticks
 */
void Blink::tick(float dt)
{
}


/**
 * draws the blink
 */
void Blink::draw() const
{
  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_LIGHTING);
  glDisable(GL_FOG);
  glPushMatrix();

  this->material->select();

  glBegin(GL_QUADS);
    glTexCoord2f(1, 1); glVertex3f(0, 0, 0);
    glTexCoord2f(1, 0); glVertex3f(1000, 0, 0);
    glTexCoord2f(0, 0); glVertex3f(1000, 1000, 0);
    glTexCoord2f(0, 1); glVertex3f(0, 1000, 0);
  glEnd();


  glPopMatrix();
  glPopAttrib();
}
